Attribute VB_Name = "Derive_Fnct"
Option Explicit
Option Base 1
'==============================================================================
' Filename: Derive.pb
' Description:
' Library to use symbolic differentiation of mathematical expressions in applications.
' Supports 5 operators, brackets, 18 mathematical functions and userdefined variables
'==============================================================================
'Derive Returned values (ExitCodes) and Constants
'==================================================
Global Const TooLongFormula     = -30
Global Const WrongNumber        = -31
Global Const Wrong1stOperand    = -32
Global Const WrongBrackets      = -33
Global Const WrongPowerNumber   = -34
Global Const ErrorInFormula     = -35
Global Const EmptyFormula       = -36
Global Const DivisionByZero     = -9'=#e_DivByZero

'
Public Declare Function SetDiffLogF Lib "aNuMet.dll" ( _
       ByVal LogF As Byte,  _
       ByVal LogFileName As String) As Long
' set Log flag on (1) and off (0) and LogFilename

'
Public Declare Function GetLast_diffErr Lib "aNuMet.dll" () As Long
' Return error code of last e_diff() call

'
Public Declare Function GetDiff_OperAndFuncs Lib "aNuMet.dll" ( _
       ByVal sRes As String) As Long
' get a string with the supported operators and functions
' return the lenght of the characters to be copied in the buffer (close to 1000), otherwise 0
' If Not enought buffer space, result will be truncated
' parameters: *sRes pointer/address to a buffer that will contain returned result

'
Public Declare Function e_diff Lib "aNuMet.dll" ( _
       ByVal sExpr As String,  _
       ByVal sVar As String,  _
       ByVal sRes As String,  _
       ByVal sResLen As Long) As Long
'calculate symbolic differentiation of Expr by variable sVar. Store result in buffer sRes
'returns lenght of returned string (even if greater than sResLen), otherwise 0 if some differentiation
'  error occurred. See GetLast_diffErr for error code. GetLast_diffErr return no error if result is truncated
'parameters: sExpr: string expression of which calculate symbolic differentiation  (es. "x^2 - 3*x +1")
'            sVar : variable by which calculate                                    (es. "x")
'            *sRes: pointer to a buffer (address) of lenght/dimension sResLen to store result
'            sResLen: length/dimension of sRes buffer (if not enought space, result will be truncated)
' PB sample: ret = e_diff("x^2-e*x+1", "x", @sRes, 100)

