EnableExplicit

;code to test aNumet.dll registration. Must be at the begin to avoid multiple calls and messages

; Global RegType1.l
; Define aNuMet.l, *f
; aNuMet = OpenLibrary(#PB_Any, "aNuMet.dll")
; *f = GetFunction(aNuMet, "GetRegType")                                      ;test aNuMet.dll
; RegType1 = CallFunctionFast(*f)
;------------------------------------------------------------------------------------------

Define s.s, res.d
Define T1.l, k.l, ww.w, cc.c, kk.c, ret.l
Define s1.s, s2.s, lretStr.s

Dim a.d(1, 1);each dimension goes from 0 To 1, total 2x2
a(0,1)=2: a(1,0)=1 ;(<>2)
ret=-99;any number different from -1, 0 or 1

CompilerIf 1
    IncludeFile "aNuMet.pbpt"       ;pbpt = PureBasic ProtoType file
    IncludeFile "EqParser.pbpt"
    IncludeFile "Solver.pbpt"    

CompilerElse                        ;for debug purpose (you should use the previous IncludeFile)
    IncludeFile "Solver.pb"

CompilerEndIf

;initialize DLL, setting aElemOrder
ret=aElemOrderEx(@a(0,0), 0)

;Or even (old instruction)
ret=CallFunctionFast(aElemOrderEx._aElemOrderEx, @a(0,0), 0) ;Tp=0 Detect aElemOrder for PB; Tp values: 0=Detect, 1=DetectStr, 2=Set, 3=Get

;========================================================
;sample for matrix functions
;========================================================

ret = ResetEqParser()
ShowMsgs(1)

;Define And solve a Matrix System {vX} = [A(rc,rc)]*{vB}
Dim vetX.d(2):Dim mtrA.d(2, 2):Dim vetB.d(2)
Define ret.l, addr.l

;set the matrix elements
mtrA(0, 0) = 0: mtrA(0, 1) = 1: mtrA(0, 2) = 4.1
mtrA(1, 0) = 78.36: mtrA(1, 1) = 90: mtrA(1, 2) = 72.2747
mtrA(2, 0) = 7.0024: mtrA(2, 1) = 9.0031: mtrA(2, 2) = 62.6245

;show elements of mtrAT in a messagebox and get in a string
lretStr=PeekS(aPrint(@mtrA(),3,3,"MsgBox","" ,"mtrA()=",""))


ret=aDet(@mtrA(), 3, @res)
;show result
ret=MessageRequester("Sample 1:","Determinant of mtrA(): "+ StrD(res))
    
    
;set the known values
vetB(0) = 4: vetB(1) = 3: vetB(2) = 7

ret=aSist(@mtrA(), 3, @vetB(), @vetX())

;get elements of matrix in a string and show in debug window
lretStr=PeekS(aPrint(@mtrA(),3,3,"String","","mtrA()=",""))
Debug lRetStr

lRetStr=Space(1000);initialize returned string (necessary)
;get elements of solution vector in a string
ret=aPrintEx(@vetX(),3,1,@"String",0,@"vetX()",0, @lRetStr)
;show string in msgbox
ret=MessageRequester("MsgBox", lRetStr)


;traspose matrix
ret=aTrasp(@mtrA(), 3, 3)
;show elements of mtrAT in a messagebox and get in a string
lretStr=PeekS(aPrint(@mtrA(),3,3,"MsgBox","" ,"mtrA()T=",""))
Debug lRetStr

ret=aDet(@mtrA(), 3, @res)
;show result
ret=MessageRequester("Sample 2","Determinant of mtrA()T: "+ StrD(res))


;========================================================
;sample for equation parser
;========================================================
Define txt1.s, dRet.d

ShowMsgs(1)
ret = ResetEqParser()

;define equation
txt1 = "xx+ func1 + func2 + sin(yy*#to_rad) - Log(10)/(1+yy^2)"

;define variables
ret = SetVarFunct("xx", "12", 0)
ret = SetVarFunct("yy", "2", 0)

;define functions (1=verify functions' name ambiguity)
ret = SetVarFunct("func1", "xx+yy", 1)
ret = SetVarFunct("func2", "xx-yy", 1)

;(1=verify functions' name ambiguity)
ret = e_eval(txt1, @dRet, 1)

Debug ""
Debug "Expression: "+txt1
Debug "Result:"+StrD(dRet)

; set single variable 'x' equation
txt1 = "1 + 12*x - Log(x) + 2*x^2"
; integrate equation between 1 To 1000 With 500 steps
ret = Integrate(txt1, 1, 1000, 500, 1, "x", @dRet)
;show result
Debug ""
Debug "Equation y=(" + txt1 + "):"
Debug "Integration (Trapezoidal method) between 1 to 1000 with 500 steps: "
Debug "Result is: " + StrD(dRet)

testMatr:
;========================================================
;sample for matrix parser
;========================================================
Define st.s, txt2.s, mMemID.l, r1.l, c1.l

ReSetEqParser()
ShowMsgs(0)

;first we create and store some matrices into the DLL

;string matrix, separator is the simbol ';'
;this format supports expressions; matrix elements are parsed (spaces are trimmed) by SetStrMatrix function
;    name ;rows;cols;mA(0,0);mA(0,1);...
st = "[mB];   3;   3;      0;      1; 2; 1.2; 2.2; 3.2; 1; 2; 16.6866371434679*sin(0.5)"; 
ret = SetStrMatrix(st, 1, 1)                            ;store matrix in DLL

st = "[vB];   3;   0;     1;      2; 4"; 
ret = SetStrMatrix(st, 1, 0)                            ;store vector in DLL, it will be stored as a matrix mB2(2, 0)

st = "[mC];   3;   3;      1;      1; 4; 0; 3; 1; 4; 3; 5"; 
ret = SetStrMatrix(st, 1, 1)                            ;store matrix in DLL

;std matrix
Dim mC.d(2, 2)
mC(0, 0) = 1: mC(0, 1) = 1: mC(0, 2) = 4
mC(1, 0) = 0: mC(1, 1) = 3: mC(1, 2) = 1
mC(2, 0) = 4: mC(2, 1) = 3: mC(2, 2) = 5
ret=SetMatrix("[mC]", @mC(), 3, 3, 1)


;1. simple calculation
;---------------------
txt2="det([mB] + [mC])"
ret = e_eval(txt2, @dRet, 1)
; we know result is a number
Debug "Result of: " + txt2 + " is " +StrD(dRet)


;2. sample calculation
;----------------------
txt2="([mB]*[mB] + 2*[mC]*[mB] - [mC]^2)"
ret = e_eval(txt2, @dRet, 1)
;we know result is a matrix
ret=aPrint(@dRet, 3, 3, "MsgBox", "", "[mX] = ", "")

; if we don't know if result is a number or a matrix
If GetResultType() = #nnIsMatrix ;also if ret = #nnIsNumber
    mMemID = FindMatrix(Str(dRet), (#SrcMatrPtr + #RetMatrPtr), @r1, @c1)   ;get result matrix stored in DLL
    Dim mResult.d(r1, c1)                                                   ;dimension proper matrix
    ret = aCopyArray(mMemID, @mResult(), r1, c1)                            ;store result in Matrix mResult
    ret=aPrint(@mResult(), r1, c1, "MsgBox", "", "[mResult] = ", "")        ;show mResult
    Debug PeekS(ret)                                                       ;get result string
Else
    Debug "Result: "+StrD(dRet)                                             ;show result

EndIf

;3. sample calculation
;---------------------
txt2="([mB] + [mC])^2"
ret = e_eval(txt2, @dRet, 1)
;if we don't need the matrix content and we know the dimensions, we can only show the results
ret=aPrint(dRet, r1, c1, "MsgBox", "", txt2, "")                            ;show Result

;4. sample calculation
;---------------------
txt2="([mB] * [mB]I)"
ret = e_eval(txt2, @dRet, 1)
;if we don't need the matrix content and we know the dimensions, we can only show the results
ret=aPrint(dRet, r1, c1, "MsgBox", "", txt2, "")                            ;show Result

;5. sample calculation
;---------------------
txt2="syst((2*[mC]);([vB]+[vB])) + [vB]"
ret = e_eval(txt2, @dRet, 1)
ret=aPrint(dRet, r1, 1, "MsgBox", "", txt2, "")                             ;show Result

;6. sample calculation
;---------------------
txt2 = "vcoeff((2*[mC]); ([vB]+[vB]); (3-1))"
ret = e_eval(txt2, @dRet, 1)
ret=aPrint(dRet, 3, 1, "MsgBox", "", txt2, "")                              ;show Result

;7. sample error (vB is not squared, determinant is not existing)
;----------------------------------------------------------------
txt2 = "det([vB])"
ret = e_eval(txt2, @dRet, 1)
If GetE_Error() = #aMatrOK                                                  ;test error
    Debug txt2 + " = " + Str(dRet)
Else
    Debug "Error n. = " + Str(GetE_Error())
    Debug "Error Descr = " + PeekS(GetE_ErrDescr(GetE_error()))
EndIf

End

; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 35
; FirstLine = 10
; Folding = -
; UseIcon = RULERS.ICO
; Executable = aNuMet_PBDemo.exe